;ZRN2
; 9-10-11
;  
;
; - - - - -
          list      p=16f676  ;
          __CONFIG  03FF4H    ;
; - - - - -
;                           
; - - - - -
INDF     EQU       00H        ;
TIMER0   EQU       01H        ;
OPTION_REG EQU     81H        ;
PC       EQU       02H        ;
STATUS   EQU       03H        ;
FSR      EQU       04H        ;
PORTA    EQU       05H        ;
PORTC    EQU       07H        ;
TRISA    EQU       85H        ;
TRISC    EQU       87H        ;
INTCON   EQU       0BH        ;
PIR1     EQU       0CH        ;
PIE1     EQU       8CH        ;
TMR1L    EQU       0EH        ;
TMR1H    EQU       0FH        ;
T1CON    EQU       10H        ;
CMCON    EQU       19H        ;
VRCON    EQU       99H        ;
PCON     EQU       8EH        ;
OSCCAL   EQU       90H        ;
ANSEL    EQU       91H        ;
WPUA     EQU       95H        ;
IOCA     EQU       96H        ;
ADRESH   EQU       1EH        ;
ADRESL   EQU       9EH        ;
ADCON0   EQU       1FH        ;
ADCON1   EQU       9FH        ;
EEDATA   EQU       9AH        ;
EEADR    EQU       9BH        ;
EECON1   EQU       9CH        ;
EECON2   EQU       9DH        ;
; - - - - -
; O
; - - - - -
TEKH     EQU       20H        ;  
TEKL     EQU       21H        ;   
YCTA     EQU       22H        ;  
YCTI     EQU       23H        ;  
SUM0     EQU       24H        ;0 
SUM1     EQU       25H        ;1 
S1       EQU       26H        ; 
SR0      EQU       27H        ; 
S2       EQU       28H        ;  TMR1L,4(5)!
P        EQU       29H        ;   16+
SB1      EQU       2AH        ; 1- 
SE1      EQU       2BH        ; 1- 
SB2      EQU       2CH        ; 2- 
SE2      EQU       2DH        ; 2- 
PRM      EQU       2EH        ; 
SU       EQU       2FH        ; 
DAT      EQU       30H        ; 
SGN      EQU       31H        ; 
KU       EQU       32H        ; 
VK       EQU       33H        ; 
S3       EQU       34H        ;  20 
S4       EQU       35H        ;
SI       EQU       36H        ;
VI       EQU       37H        ;
D        EQU       38H        ;
SI4      EQU       39H        ;
K1       EQU       3AH        ; 
K2       EQU       3BH        ;
CONST3   EQU       3CH        ;
POZ      EQU       5FH        ;
WREN     EQU       .2         ;
WR       EQU       .1         ;
; - - - - -
; 1.
; - - - - -
         ORG       0          ;
         GOTO      INIT       ;
         NOP                  ;
; - - - - -
; 2.
; - - - - -
INIT     BSF       STATUS,5   ;1
         MOVLW     .252       ;
         MOVWF     OSCCAL     ; 
         MOVLW     .0         ;  !
         MOVWF     ADCON1     ;   500
         MOVLW     B'10000000';=4
         MOVWF     OPTION_REG ; 
         MOVLW     .136       ;
         MOVWF     INTCON     ;   RA(.136)
         CLRF      PIE1       ;  (.201)
         MOVLW     B'00111011'; , RA2 
         MOVWF     TRISA      ;
         MOVLW     .6         ;!!
         MOVWF     TRISC      ;1-2 ,  
         MOVLW     .172       ;VR=2,5V
         MOVWF     VRCON      ; 
         CLRF      PCON       ;   
         CLRF      WPUA       ;  
         CLRF      IOCA       ; 
         MOVLW     .32        ;!!
         MOVWF     ANSEL      ;  RC1 
         BCF       STATUS,5   ; 0
         CLRF      PORTC      ;   
         MOVLW     .48        ;
         MOVWF     T1CON      ;1 , 1/8
         MOVLW     .20        ;!  VR (.19!)
         MOVWF     CMCON      ; 
         MOVLW     .128       ;
         MOVWF     SUM0       ;
         MOVLW     .4         ;
         MOVWF     SUM1       ;
         MOVLW     .40        ;
         MOVWF     P          ;
         CLRF      SUM0       ;
         CLRF      SUM1       ;
         CLRF      S3         ;
         CLRF      KU         ;
         CLRF      VK         ;
         CLRF      SGN        ;
         MOVLW     .1         ;
         MOVWF     SU         ;
         MOVWF     DAT        ;
         BCF       STATUS,5   ;!
         MOVLW     .200       ;2 
         MOVWF     YCTI       ;
         GOTO      ADP0       ;!
; - - - - -  0
ADP0     BTFSS     PIR1,3     ;
         GOTO      ADP0       ;
         BTFSS     CMCON,6    ;+   
         GOTO      ADP0       ;
         CALL      CL1        ;
         CALL      DR2        ;
         CALL      REG1       ;
         CALL      CLDAT      ;
         BCF       STATUS,0   ;
         INCF      S3         ;
         MOVLW     .50        ;
         SUBWF     S3,0       ;
         BTFSS     STATUS,0   ;
         GOTO      AD1        ;
         CLRF      S3         ;
         GOTO      AD1        ;
AD1      BCF       PIR1,3     ;
         GOTO      ADP0       ;
; - - - - -  1
ADP1     NOP                  ;
         CALL      REG1       ;
         BCF       STATUS,0   ;
         INCF      S3         ;
         MOVLW     .50        ;
         SUBWF     S3,0       ;
         BTFSS     STATUS,0   ;
         GOTO      ADP1       ;
         CLRF      S3         ;
         GOTO      ADP1       ;
; - - - - -
;   
; - - - - -
ADC1     BSF       STATUS,5   ;
         CLRF      INTCON     ; 
         BCF       STATUS,5   ;
         MOVLW     B'10010101';  RC-
         MOVWF     ADCON0     ; 5, , 
         CALL      ZAD2       ; 
         BSF       ADCON0,1   ; 
         BTFSC     ADCON0,1   ; 
         GOTO      $-1        ;
         MOVFW     ADRESH     ; 
         MOVWF     TEKH       ;   
         BSF       STATUS,5   ;
         MOVFW     ADRESL     ;  
         BCF       STATUS,5   ;
         MOVWF     TEKL       ; TEKL
         BCF       STATUS,0   ;  
         RRF       TEKH,1     ;  
         RRF       TEKL,1     ; 8 
         BCF       STATUS,0   ;
         MOVFW     YCTI       ;  
         SUBWF     TEKL,0     ;  YCTI
         BTFSC     STATUS,0   ;
         GOTO      ADPU1      ;
         BCF       PORTC,4    ;
         GOTO      ADP2       ;
ADPU1    BSF       PORTC,4    ;  
         GOTO      ADP2       ;
ADP2     BCF       STATUS,0   ;
         MOVFW     TEKL       ;
         ADDWF     SUM0,1     ;
         BTFSS     STATUS,0   ;
         INCF      SUM1,1     ;
         CLRF      TEKL       ;
         CLRF      TEKH       ;
         BSF       STATUS,5   ;
         MOVLW     .136       ;
         MOVWF     INTCON     ; 
         BCF       STATUS,5   ;
         RETURN               ;
; - - - - -  
CL1      NOP                  ;
         BTFSC     SGN,1      ; 2
         GOTO      C30        ; 60 
         BTFSC     SGN,0      ; 1
         GOTO      C31        ;
C18      MOVLW     .11        ;  A 512(9+1)
         MOVWF     S1         ;-! 10 
C15      DECFSZ    S1         ;-
         GOTO      C16        ;-
         GOTO      C17        ;-
C16      BCF       STATUS,0   ;-
         RRF       SUM1,1     ;-
         RRF       SUM0,1     ;-
         GOTO      C15        ;-
C17      MOVLW     .63        ;! 31 
         ANDWF     SUM0,1     ;-
C20      MOVFW     SUM0       ;- 
         MOVWF     SR0        ;- SB1
         ADDLW     .50        ;-!20
         MOVWF     PRM        ; 
         COMF      P,0        ;
         ADDWF     PRM,0      ;-
         MOVWF     SB1        ;- SB1
         ADDLW     .100       ;!39
         MOVWF     SB2        ;- SB2
         MOVFW     P          ;- SE1
         ADDLW     .50        ;!20
         MOVWF     PRM        ;
         COMF      SR0,0      ;
         ADDWF     PRM,0      ;
         MOVWF     SE1        ;- SE1
         ADDLW     .100       ;!39
         MOVWF     SE2        ;- SE2
         GOTO      C33        ;
C30      MOVLW     .35        ; 2
         MOVWF     SB1        ; 60 
         MOVLW     .65        ;
         MOVWF     SE1        ;
         MOVLW     .135       ;
         MOVWF     SB2        ;
         MOVLW     .165       ;
         MOVWF     SE2        ;
         GOTO      C33        ;
C31      CLRF      SGN        ; 1  
C33      NOP                  ;
         RETURN               ;
; - - - -  
REG1     NOP                  ;!
         BTFSC     PORTA,4    ;  
         GOTO      RG0        ;-
         BSF       KU,0       ;-
         GOTO      RG1        ;-
RG0      BTFSS     KU,0       ;-
         GOTO      RG1        ; 
         BCF       KU,0       ;
         BCF       STATUS,2   ;
         INCF      SU         ;
         MOVLW     .1         ;
         MOVWF     VK         ;
RG1      MOVLW     .1         ;  1
         SUBWF     SU,0       ;- 
         BTFSS     STATUS,2   ; 1
         GOTO      RG3        ;
         BTFSS     DAT,0      ; 1
         GOTO      RG11       ;DAT=1
         BCF       PORTA,2    ;
         GOTO      RG6        ;
RG11     BTFSS     DAT,1      ;
         GOTO      RG2        ;
;        BCF       STATUS,2   ; 2, 
         BTFSC     S3,1       ;DAT=2, =40 
         GOTO      IN11       ;
         BTFSC     S3,2       ;""
         BSF       PORTA,2    ;
         GOTO      RG6        ;
IN11     BCF       PORTA,2    ;
         GOTO      RG6        ;
RG2      BTFSS     DAT,2      ; 3, 
         GOTO      RG6        ;DAT=4
         BTFSC     S3,3       ;=160 
         GOTO      IN21       ;
         BTFSC     S3,4       ;""
         BSF       PORTA,2    ;
         GOTO      RG6        ;
IN21     BCF       PORTA,2    ;
         GOTO      RG6        ;
RG3      MOVLW     .2         ;  2
         SUBWF     SU,0       ;- 1
         BTFSS     STATUS,2   ;
         GOTO      RG4        ;
         BCF       STATUS,2   ;
         BTFSC     S3,5       ;=640 
         GOTO      IN31       ;
         BSF       PORTA,2    ;
         GOTO      IN32       ;
IN31     BCF       PORTA,2    ;
IN32     INCFSZ    VK,1       ;
         GOTO      RG6        ;
         MOVLW     .1         ;
         MOVWF     SGN        ;  1
         MOVLW     .1         ;
         MOVWF     VK         ;
         GOTO      RG6        ;
RG4      MOVLW     .3         ;  3
         SUBWF     SU,0       ;- 2
         BTFSS     STATUS,2   ;
         GOTO      RG5        ;
         BCF       STATUS,2   ;
         BSF       PORTA,2    ; 
         INCFSZ    VK,1       ;
         GOTO      RG6        ;
         MOVLW     .2         ;
         MOVWF     SGN        ;  2
         MOVLW     .1         ; 60 
         MOVWF     VK         ;
         GOTO      RG6        ;
RG5      MOVLW     .1         ;
         MOVWF     SU         ;
         BCF       PORTA,2    ;
RG6      NOP                  ;
         RETURN               ;
; - - - - - -  
CLDAT    MOVLW     .1         ; 
         MOVWF     DAT        ;
         BCF       STATUS,0   ;
         MOVLW     .15        ;
         SUBWF     SB1        ;
         BTFSC     STATUS,0   ;
         GOTO      CLD1       ;
         MOVLW     .2         ; 2, 
         MOVWF     DAT        ;
         GOTO      CLD2       ;
CLD1     MOVLW     .60        ;
         SUBWF     SE1        ;
         BTFSC     STATUS,0   ;
         GOTO      CLD2       ;
         MOVLW     .4         ;
         MOVWF     DAT        ; 3, 
CLD2     BCF       STATUS,0   ;
         RETURN               ;
; - - - - - -     
DR2      CLRF      S2         ;
         BSF       T1CON,0    ; 
DO1      BCF       PORTC,5    ;  O
         BCF       STATUS,0   ;3  5 
         BTFSC     TMR1L,4    ;!4-  128
         GOTO      DO4        ;
         BCF       PORTC,3    ;
         GOTO      DO2        ;
DO4      BCF       PORTC,3    ;
         INCF      S2,1       ;
         CALL      ADC1       ;
DO2      BCF       STATUS,0   ; S2
         MOVFW     SB1        ;
         SUBWF     S2,0       ;
         BTFSS     STATUS,0   ;
         GOTO      DO1        ;
         NOP                  ;  O
D21      BCF       PORTC,5    ;  2
         BCF       STATUS,0   ;3  5 
         BTFSC     TMR1L,4    ;!
         GOTO      D24        ;
         BCF       PORTC,3    ;
         GOTO      D22        ;
D24      BSF       PORTC,3    ;
         INCF      S2,1       ;
         CALL      ADC1       ;
D22      BCF       STATUS,0   ; S2
         MOVFW     SE1        ;
         SUBWF     S2,0       ;
         BTFSS     STATUS,0   ;
         GOTO      D21        ;
         NOP                  ;  2
D31      BCF       PORTC,5    ;  3
         BCF       STATUS,0   ;3  5 
         BTFSC     TMR1L,4    ;
         GOTO      D34        ;
         BCF       PORTC,3    ;
         GOTO      D32        ;
D34      BCF       PORTC,3    ;
         INCF      S2,1       ;
         CALL      ADC1       ;
D32      BCF       STATUS,0   ; S2
         MOVFW     SB2        ;
         SUBWF     S2,0       ;
         BTFSS     STATUS,0   ;
         GOTO      D31        ;
         NOP                  ;  3
D41      NOP                  ;
;        BCF       PORTC,3    ;  4
         BCF       STATUS,0   ;3 / 5 
         BTFSC     TMR1L,4    ;
         GOTO      D44        ;
         BCF       PORTC,5    ;
         BCF       PORTC,3    ;
         GOTO      D42        ;
D44      BSF       PORTC,5    ;
         BSF       PORTC,3    ;
         INCF      S2,1       ;
         CALL      ADC1       ;
D42      BCF       STATUS,0   ; S2
         MOVFW     SE2        ;
         SUBWF     S2,0       ;
         BTFSS     STATUS,0   ;
         GOTO      D41        ;
         NOP                  ;  4
D51      BCF       PORTC,5    ;  5
         BCF       STATUS,0   ;3  5 
         BTFSC     TMR1L,4    ;!
         GOTO      D54        ;
         BCF       PORTC,3    ;
         GOTO      D52        ;
D54      BCF       PORTC,3    ;
         INCF      S2,1       ;
         CALL      ADC1       ;
D52      BCF       STATUS,0   ; S2
         MOVLW     .170       ;!74
         SUBWF     S2,0       ;
         BTFSS     STATUS,0   ;
         GOTO      D51        ;
D55      NOP                  ;  5
         BCF       T1CON,0    ;
         RETURN               ;        
; - - - - - -
ZAD      MOVLW     .25        ; 0,1 
         ADDLW     -1         ;
         BTFSS     STATUS,2   ;
         GOTO      $-2        ;
         RETURN               ;
;- - - - - -
ZAD2     MOVLW     .5         ; 0,02 
         ADDLW     -1         ;
         BTFSS     STATUS,2   ;
         GOTO      $-2        ;
         RETURN               ;
; - - - - - -
ZAD3     MOVLW     .125        ; 0,5 
         ADDLW     -1         ;
         BTFSS     STATUS,2   ;
         GOTO      $-2        ;
         RETURN               ;
;- - - - - -  
         END                  ;-506-

          
